import 'package:flutter/widgets.dart';
import 'package:forma/element_form.dart';
import 'package:forma/model_form.dart';
import 'i_layout.dart';

/// [AutoLayout] is a extension on [ILayout] and can be provided to the static [withLayout] factory methods of [ElementForm] and [ModelForm].
/// [AutoLayout] generates the layout of the form automatically by adding every form element to a column based on order.
class AutoLayout implements ILayout {
  @override
  Widget layout(BuildContext context, widgets) {
    List<Widget> widgetList = List<Widget>();

    TreeMapper mapper = TreeMapper((dynamic node) {
      if (node is Widget) {
        widgetList.add(node);
      }

      return node;
    });

    mapper.map(widgets);

    return Column(
      children: widgetList,
    );
  }
}
